/* smcpst.c */

/*
 * (C) Copyright 1989,1990
 * All Rights Reserved
 *
 * Alan R. Baldwin
 * 721 Berkeley St.
 * Kent, Ohio  44240
 *
 * Modified for SMC88
 * (c) Copyright 1995
 *
 * Altair in Planning Group "HALO"
 * NBG01720@niftyserve.or.jp
 */

#include<stdio.h>
#include<setjmp.h>
#include"asm.h"
#include"smc.h"

struct mne mne[]={


	/* system */

	NULL,	"CON",		S_ATYP, 0,A_CON,
	NULL,	"OVR",		S_ATYP, 0,A_OVR,
	NULL,	"REL",		S_ATYP, 0,A_REL,
	NULL,	"ABS",		S_ATYP, 0,A_ABS|A_OVR,
	NULL,	"NOPAG",	S_ATYP, 0,A_NOPAG,
	NULL,	"PAG",		S_ATYP, 0,A_PAG,

	NULL,	".byte",	S_BYTE, 0,0,
	NULL,	".db",		S_BYTE, 0,0,
	NULL,	".word",	S_WORD, 0,0,
	NULL,	".dw",		S_WORD, 0,0,
	NULL,	".ascii",	S_ASCII,0,0,
	NULL,	".asciz",	S_ASCIZ,0,0,
	NULL,	".blkb",	S_BLK,	0,1,
	NULL,	".ds",		S_BLK,	0,1,
	NULL,	".blkw",	S_BLK,	0,2,
	NULL,	".page",	S_PAGE, 0,0,
	NULL,	".title",	S_TITLE,0,0,
	NULL,	".sbttl",	S_SBTL, 0,0,
	NULL,	".globl",	S_GLOBL,0,0,
	NULL,	".area",	S_DAREA,0,0,
	NULL,	".even",	S_EVEN, 0,0,
	NULL,	".odd",		S_ODD,	0,0,
	NULL,	".if",		S_IF,	0,0,
	NULL,	".else",	S_ELSE, 0,0,
	NULL,	".endif",	S_ENDIF,0,0,
	NULL,	".include", S_INCL, 0,0,
	NULL,	".radix",	S_RADIX,0,0,
	NULL,	".org",		S_ORG,	0,0,
	NULL,	".module",	S_MODUL,0,0,

	/* smc88 */

	NULL,	"ld",		S_LD,	0,0x40,
	NULL,	"ex",		S_EX,	0,0xC7,
	NULL,	"add",		S_ADD,	0,0x00,
	NULL,	"adc",		S_ADC,	0,0x08,
	NULL,	"sub",		S_ADD,	0,0x10,
	NULL,	"sbc",		S_SBC,	0,0x18,
	NULL,	"and",		S_AND,	0,0x20,
	NULL,	"or",		S_OR,	0,0x28,
	NULL,	"xor",		S_AND,	0,0x38,
	NULL,	"cp",		S_CP,	0,0x30,
	NULL,	"bit",		S_BIT,	0,0x96,
	NULL,	"inc",		S_INC,	0,0x80,
	NULL,	"dec",		S_INC,	0,0x88,
	NULL,	"cpl",		S_RL,	0,0xA0,
	NULL,	"neg",		S_RL,	0,0xA4,
	NULL,	"mlt",		S_INH2, 0,0xD8,
	NULL,	"div",		S_INH2, 0,0xD9,
	NULL,	"pack",		S_INH1, 0,0xDE,
	NULL,	"upck",		S_INH1, 0,0xDF,
	NULL,	"sep",		S_INH2, 0,0xA8,
	NULL,	"rl",		S_RL,	0,0x90,
	NULL,	"rlc",		S_RL,	0,0x94,
	NULL,	"rr",		S_RL,	0,0x98,
	NULL,	"rrc",		S_RL,	0,0x9C,
	NULL,	"sla",		S_RL,	0,0x80,
	NULL,	"sll",		S_RL,	0,0x84,
	NULL,	"sra",		S_RL,	0,0x88,
	NULL,	"srl",		S_RL,	0,0x8C,
	NULL,	"push",		S_PUSH, 0,0xA0,
	NULL,	"pop",		S_PUSH, 0,0xA8,
	NULL,	"jrs",		S_JRS,	0,0xE0,
	NULL,	"jrl",		S_JRL,	0,0xEC,
	NULL,	"djr",		S_DJR,	0,0xF5,
	NULL,	"jp",		S_JP,	0,0xFD,
	NULL,	"cars",		S_CARS, 0,0xF0,
	NULL,	"carl",		S_CARL, 0,0xE8,
	NULL,	"call",		S_CALL, 0,0xFB,
	NULL,	"int",		S_INT,	0,0xFC,
	NULL,	"ret",		S_INH1, 0,0xF8,
	NULL,	"rete",		S_INH1, 0,0xF9,
	NULL,	"rets",		S_INH1, 0,0xFA,
	NULL,	"nop",		S_INH1, 0,0xFF,
	NULL,	"halt",		S_INH2, 0,0xAE,
	NULL,	"swap",		S_SWAP, 0,0xF6,
	NULL,	"slp",		S_INH2, 0,0xAF
};
