/**********************************************************************
  ChipCard Development Kit on UNIX

  file : chipcard.h

  AUTHOR  : $Author$
  DATE    : $Date$
  VERSION : $Revision$

  Copyright 1995 (c) Masahiko KIMOTO, All rights reserved.
**********************************************************************/

/*
   include fileSPP88ʤɤpre-processercppǤ٤Ƥ
   pre-proccessing򤪤ʤΤΤǤ롣
   ˤäƤ礯asxxxxϤȤѤ뤳ȤǤե뤬
   ϲǽǤ뤬񼰤DOSγȯĶΤΤȤϼ㴳ۤʤäΤ
   ʤäƤޤ

   :

   #lod 450988h   #lod(0x450988)
   API   ClearScreen    API(ClearScreen)

   ޤΥեPCCARD.MAC  API.INCƤȤˤƤ롣
*/

/*
 ƥ
*/
#define	XSize		12		/* ɽ*/
#define	MaxXSize	24		/* ɽ*/
#define	YSize		3		/* ɽԿ*/
#define	MaxYSize	5		/* ɽԿ*/
#define	CharWidth	6		/* ʸ(ɥåñ)*/

/**/
/* ե饰*/
/**/
#define	ON		0x01
#define	OFF		0x00
#define	TRUE		0x01
#define	FALSE		0x00

/**/
/* ƥॳǥե饰*/
/**/
#define	zero		0x01		/* */
#define	carry		0x02		/* ꡼*/
#define	overflow	0x04		/* Сե*/
#define	negative	0x08		/* ͥƥ*/
#define	decimal		0x10		/* ǥޥ*/
#define	unpack		0x20		/* ѥå*/
#define	intlevel0	0x00		/* I0,1	٥룰*/
#define	intlevel1	0x40		/*	٥룱*/
#define	intlevel2	0x80		/*	٥룲*/
#define	intlevel3	0xc0		/*	٥룳(NMI only)*/

/*
 ܡ

 ϻå⡼ɤʤСեȿ(bit0-3)ϥץꥱ
 ̤̣ޤ
   0=(̾) 1= 2= 
*/
#define	KBD_READY	0x80		/* ϥե饰*/
#define	KBD_NUMLOCK	0x40		/* å⡼ɡʣϡ*/
#define	KBD_NORMAL	0x00		/* ʸ⡼ɡ¿ʥեȡ*/
#define	KBD_LOCK	0x20		/* å*/
#define	KBD_REL		0x00		/* å*/
#define	KBD_KANA	0x10		/* ʥ⡼*/
#define	KBD_ALPHA	0x00		/* ѿ⡼*/

#define	KBD_SFTNUM	0x00		/* (̾)*/
#define	KBD_SFTCALC	0x01		/* */
#define	KBD_SFTCLOCK	0x02		/* */

/* ֹ()*/
#define	KNO_POWER	16		/* "ON/OFF"	ɤޤ*/
#define	KNO_FUNC	8		/* "ǽ"	ɤޤ*/
#define	KNO_OK		7		/* "OK"*/
#define	KNO_CCE		6		/* "C/CE"*/

/* ()*/
#define	KCD_ONOFF	0x01		/* "ON/OFF"	ɤޤ*/
#define	KCD_KINOU	0x02		/* "ǽ"	ɤޤ*/
#define	KCD_CHAR	0x03		/* "//"	ɤޤ*/
#define	KCD_SMALL	0x04		/* "ʸ"	ɤޤ*/
#define	KCD_DELREC	0x05		/* "ڎĎ޺"*/
#define	KCD_INSERT	0x06		/* ""*/
#define	KCD_DELETE	0x07		/* ""	(̤)*/
#define	KCD_CCE		0x08		/* "C/CE"*/
#define	KCD_FIND	0x08		/* ""*/
#define	KCD_MREAD	0x09		/* "MR"*/
#define	KCD_MMINUS	0x0a		/* "M-"*/
#define	KCD_MCLR	0x0b		/* "MC"*/
#define	KCD_MPLUS	0x0c		/* "M+"*/
#define	KCD_OK		0x0d	        /* "OK"*/
#define	KCD_AMPM	0x10		/* "AM/PM"*/
#define	KCD_TIMESET	0x10		/* "礻"*/
#define	KCD_ILLEGAL	0x11		/*		̤*/
#define	KCD_UP		0x1c		/* ""*/
#define	KCD_DOWN	0x1d		/* ""*/
#define	KCD_RIGHT	0x1e		/* ""*/
#define	KCD_LEFT	0x1f		/* ""*/

/*
   ޥ
*/
				/* 󥿥ץȶػ*/
#define DI	.db   0xa7,0x9d,(intlevel3)
/*
	push	sc
	or	sc,#intlevel3		;IntLevel<- Int3 later(NMI only)
*/

					/* 󥿥ץ*/
#define EI      .db   0xaf
/*
	pop	sc
*/


#define CarryOn .db  0x9d,(carry)		/* ꡼*/
/*	or	sc,#carry */

#define CarryOff .db 0x9c,(~carry)		/* ꡼*/
/*	and	sc,#~carry */


#define Zero	.db 0x9d,(zero) 		/* */
/*	or	sc,#zero */


#define NoneZero  .db 0x9c,(^zero)		/* */
/*	and	sc,#~zero */

/* ĥ˥åȤϤΥޥѤ뤳ȡ*/
/* XP,IX˲뤳Ȥ(ץꥱƬǼ¹Ԥ٤)*/
#define EXTSTK	\
	ld	xp,#0\
	ld	ix,#0ff01h\
	ld	[ix],#20h\
	ld	sp,#0400h		/* StackArea<- 200300H-200400H(256bytes)*/\


/* API
   APIƤӽФޥ
   ʲΤ褦˻Ѥޤ
   
   API	ClearScreen		;;API API_No ȤƻȤޤ
   
   ld	hl,#0104		;;APIѥ᡼ϻ˥ɤƤ
   API	Locate
   
   ld	xp,#pod message		;;IXѤAPIǤϤΤ褦XPꤷ
   ld	ix,#lod Message		;;Ƥ
   API	PutStr2
*/

#define API(x)	.db 0xa5,0xce,0xc5,0x00,0xfb,((x)&0xff),(((x)>>8) & 0xff),0xad
/*
   This set of magic numbers means ....

   push	ep \
   ld	ep,#0\
   call [(x).w]
   pop ep
*/

#define SetTextSize	0x90
/*;	ƥȲ̥ѹ
;	ɸ:12x3(36bytes)ΥХåեĸ
;	ĥ:24x5(120bytes)ΥХåեǽ
;	ĥ̤ǤϸѤΤդ뤳
;
;	IN:	A	0=ɸ ¾=ĥ
;	OUT:	̵
;	Reg.	¸*/

#define	SetTextBuffer	0x92
/*;	ƥȥХåեꤹ
;
;	IN:	A	ƥȥХåեڡ
;		HL	ƥȥХåեɥ쥹
;	OUT:	̵
;	Reg.	¸*/

#define	ClearScreen	0x94
/*;	̾õ
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	ScrollUp	0x96
/*;	
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	ScrollDown	0x98
/*;	
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	ScrollLeft	0x9a
/*;	
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	ScrollRight	0x9c
/*;	
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	MoveUp		0x9e
/*;	եåȤˤ̤ξ她
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	MoveDown	0xa0
/*;	եåȤˤ̤β
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	MoveLeft	0xa2
/*;	եåȤˤ̤κ
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	MoveRight	0xa4
/*;	եåȤˤ̤α
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	MoveAdjust	0xa6
/*;	뤬ͤ
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	Locate		0xa8
/*;	ư
;
;	IN:	L	Xɸ
;		H	Yɸ
;	OUT:	̵
;	Reg.	¸*/

#define	GetPos		0xaa
/*;	֤
;
;	IN:	̵
;	OUT:	L	Xɸ
;		H	Yɸ
;	Reg.	HLʳ¸*/

#define	GetChar		0xac
/*;	֤ʸɤ߽Ф
;
;	IN:	L	Xɸ
;		H	Yɸ
;	OUT:	A	ʸ
;	Reg.	Aʳ¸*/

#define	GetChar2	0xae
/*;	֤ʸɤ߽Ф
;
;	IN:	̵
;	OUT:	A	ʸ
;	Reg.	Aʳ¸*/

#define	PutChar		0xb0
/*;	ʸ
;
;	IN:	A	ʸ(JISCII)
;		L	Xɸ
;		H	Yɸ
;	OUT:	̵
;	Reg.	¸*/

#define	PutChar2	0xb2
/*;	ʸ()
;
;	IN:	A	ʸ(JISCII)
;	OUT:	̵
;	Reg.	¸*/

#define	PutNum2		0xb4
/*;	ͽ
;
;	IN:	A	Ͽ
;		L	Xɸ
;		H	Yɸ
;	OUT:	̵
;	Reg.	¸*/

#define	PutNum22	0xb6
/*;	ͽ()
;
;	IN:	A	Ͽ
;	OUT:	̵
;	Reg.	¸*/

#define	PutStr		0xb8
/*;	ʸ
;
;	IN:	IX	ʸ󥢥ɥ쥹
;		XP	ʸڡ
;		L	Xɸ
;		H	Yɸ
;	OUT:	̵
;	Reg.	¸*/

#define	PutStr2		0xba
/*;	ʸ()
;
;	IN:	IX	ʸ󥢥ɥ쥹
;		XP	ʸڡ
;	OUT:	̵
;	Reg.	¸*/

#define	Indicater	0xbc
/*;	󥸥ɽ
;
;	IN:	A	󥸥ֹ
;		B	ON= OFF=
;	OUT:	̵
;	Reg.	¸*/

#define	ReadKey		0xbe
/*;	ꥢ륿७ɤ߹
;	ɤϺ鱦زˣŤäޤ
;
;	IN:	̵
;	OUT:	A	0-23= 0ffh=̵
;	Reg.	Aʳ¸*/

#define	KeyMode		0xc0
/*;	⡼
;
;	IN:	A	⡼(pccard.mac)
;	OUT:	̵
;	Reg.	¸*/

#define	SenseKey	0xc2
/*;	ϥ
;
;	IN:	̵
;	OUT:	A	ϥ(JISCII)	0̵
;	Reg.	Aʳ¸*/

#define	InKey		0xc4
/*;	
;
;	IN:	̵
;	OUT:	A	ϥ(JISCII)	0̵
;	Reg.	Aʳ¸*/

#define	InKeyS		0xc6
/*;	(Ԥ)
;
;	IN:	̵
;	OUT:	A	ϥ(JISCII)
;	Reg.	Aʳ¸*/

#define	Input		0xc8
/*;	ϤԤ
;	IN:	IX	ϥХåեɥ쥹(A+1Υ뤳ȡ)
;		A	Ĺ
;		L	Xɸ
;		H	Yɸ
;	OUT:	A	λ
;	Reg.	¸*/

#define	CursorOn	0xca
/*;	
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	CursorOff	0xcc
/*;	
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	Beep		0xce
/*;	ӡײ(Ĺ)ȯ
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	Click		0xd0
/*;	ӡײ(û)ȯ
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	Wait		0xd2
/*;	֥Ȥ
;
;	IN:	A	Ȼ(10msñ)
;	OUT:	̵
;	Reg.	¸*/

#define	WaitTimerReset	0xd4
/*;	ִƻ륿ޡꤹ
;	ƻ륿ޡWaitѤʤǤ
;
;	IN:	A	ִƻ륿ޡ(10msñ)
;	OUT:	̵
;	Reg.	¸*/

#define	WaitTimer	0xd6
/*;	ִƻ륿ޡɤ߽Ф
;	ƻ륿ޡWaitѤʤǤ
;
;	IN:	̵
;	OUT:	A	ִƻ륿ޡ(10msñ)
;	Reg.	¸*/

#define	PowerSaveLock	0xd8
/*;	ѥ֤Ԥʤˤ
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	PowerSaveUnlock	0xda
/*;	ѥ֤Ԥˤ
;
;	IN:	̵
;	OUT:	̵
;	Reg.	¸*/

#define	Random		0xdc
/*;	(?)
;
;	IN:	̵
;	OUT:	A	(0-255)
;	Reg.	Aʳ¸*/

#define	Pset		0xde
/*;	ɥåȤǤ
;	ʰץեåɸϤǻꤹ뤳
;
;	IN:	L	Xɸ(0-23)
;		H	Yɸ(0-5)
;		A	0= ¾=
;	OUT:	̵
;	Reg.	¸*/

#define	Point		0xe0
/*;	ɥåȤĴ٤
;	ʰץեåɸϤǻꤹ뤳
;
;	IN:	L	Xɸ(0-23)
;		H	Yɸ(0-5)
;	OUT:	A	0= ¾=
;	Reg.	Aʳ¸*/

/*
   pageoffsetѴ
*/
/*
   in the case of which the argument is immediate number
*/
#define lod(x) ((x) & 0xffff)
#define pod(x) (((x) >> 16) & 0xff)
#define loc(x) ((x) & 0xffff)
/*
   in the case of which the argumant is label

   (in this case,PAGE shoud be 0x10)
*/
#define LOD(x) (x)
#define POD(x) (0x10)
#define LOC(x) (x)

