        .title  Test of SMC88 assembler (alpha release)

        offset  =       0x55            ;arbitrary constants
        n       =       0x20

        .blkw   1
ZMem:   .blkb   1
;A following line is written in Japanese code-page for checking.
;̍śARgƂĊ┼płpł邩ǂ̃`FbNł
        ;***********************************************************
        ;ld 16bit
        ld      ba,ba                   ; CF,E0
        ld      ba,hl                   ; CF,E1
        ld      ba,ix                   ; CF,E2
        ld      ba,iy                   ; CF,E3
        ld      ba,sp                   ; CF,F8
        ld      ba,pc                   ; CE,F9
        ld      ba,#0x10                ; C4,nn,mm
        ld      ba,AddOpr               ; B8,ll,hh
        ld      ba,[hl]                 ; CF,C0
        ld      ba,[ix]                 ; CF,D0
        ld      ba,[iy]                 ; CF,D8
        ld      ba,ZMem[sp]             ; CF,70,dd

        ld      hl,ba                   ; CF,E4
        ld      hl,hl                   ; CF,E5
        ld      hl,ix                   ; CF,E6
        ld      hl,iy                   ; CF,E7
        ld      hl,sp                   ; CF,F4
        ld      hl,pc                   ; CE,F5
        ld      hl,#0x10                ; C5,nn,mm
        ld      hl,AddOpr               ; B9,ll,hh
        ld      hl,[hl]                 ; CF,C1
        ld      hl,[ix]                 ; CF,D1
        ld      hl,[iy]                 ; CF,D9
        ld      hl,ZMem[sp]             ; CF,71,dd

        ld      ix,ba                   ; CF,E8
        ld      ix,hl                   ; CF,E9
        ld      ix,ix                   ; CF,EA
        ld      ix,iy                   ; CF,EB
        ld      ix,sp                   ; CF,FA
        ld      ix,pc                   ;
        ld      ix,#0x10                ; C6,nn,mm
        ld      ix,AddOpr               ; BA,ll,hh
        ld      ix,[hl]                 ; CF,C2
        ld      ix,[ix]                 ; CF,D2
        ld      ix,[iy]                 ; CF,DA
        ld      ix,ZMem[sp]             ; CF,72,dd

        ld      iy,ba                   ; CF,EC
        ld      iy,hl                   ; CF,ED
        ld      iy,ix                   ; CF,EE
        ld      iy,iy                   ; CF,EF
        ld      iy,sp                   ; CF,FE
        ld      iy,pc                   ;
        ld      iy,#0x10                ; C7,nn,mm
        ld      iy,AddOpr               ; BB,ll,hh
        ld      iy,[hl]                 ; CF,C3
        ld      iy,[ix]                 ; CF,D3
        ld      iy,[iy]                 ; CF,DB
        ld      iy,ZMem[sp]             ; CF,73,dd

        ld      sp,ba                   ; CF,F0
        ld      sp,hl                   ; CF,F1
        ld      sp,ix                   ; CF,F2
        ld      sp,iy                   ; CF,F3
        ld      sp,sp                   ;
        ld      sp,pc                   ;
        ld      sp,#0x10                ; CF,6E,nn,mm
        ld      sp,AddOpr               ; CF,78,ll,hh
        ld      sp,[hl]                 ;
        ld      sp,[ix]                 ;
        ld      sp,[iy]                 ;
        ld      sp,ZMem[sp]             ;

        ld      AddOpr,ba               ; BC,ll,hh
        ld      AddOpr,hl               ; BD,ll,hh
        ld      AddOpr,ix               ; BE,ll,hh
        ld      AddOpr,iy               ; BF,ll,hh
        ld      AddOpr,sp               ; CF,7C,ll,hh
        ld      AddOpr,pc               ;
        ld      AddOpr,#0x10            ;
        ld      AddOpr,AddOpr           ;
        ld      AddOpr,[hl]             ;
        ld      AddOpr,[ix]             ;
        ld      AddOpr,[iy]             ;
        ld      AddOpr,ZMem[sp]         ;

        ld      [hl],ba                 ; CF,C4
        ld      [hl],hl                 ; CF,C5
        ld      [hl],ix                 ; CF,C6
        ld      [hl],iy                 ; CF,C7
        ld      [hl],sp                 ;
        ld      [hl],pc                 ;
        ld      [hl],AddOpr             ;

        ld      [ix],ba                 ; CF,D4
        ld      [ix],hl                 ; CF,D5
        ld      [ix],ix                 ; CF,D6
        ld      [ix],iy                 ; CF,D7
        ld      [ix],sp                 ;
        ld      [ix],pc                 ;
        ld      [ix],#0x10              ;
        ld      [ix],AddOpr             ;
        ld      [ix],[hl]               ;
        ld      [ix],[ix]               ;
        ld      [ix],[iy]               ;
        ld      [ix],ZMem[sp]           ;

        ld      [iy],ba                 ; CF,DC
        ld      [iy],hl                 ; CF,DD
        ld      [iy],ix                 ; CF,DE
        ld      [iy],iy                 ; CF,DF
        ld      [iy],sp                 ;
        ld      [iy],pc                 ;
        ld      [iy],#0x10              ;
        ld      [iy],AddOpr             ;
        ld      [iy],[hl]               ;
        ld      [iy],[ix]               ;
        ld      [iy],[iy]               ;
        ld      [iy],ZMem[sp]           ;

        ld      ZMem[sp],ba             ; CF,74,dd
        ld      ZMem[sp],hl             ; CF,75,dd
        ld      ZMem[sp],ix             ; CF,76,dd
        ld      ZMem[sp],iy             ; CF,77,dd
        ld      ZMem[sp],sp             ;
        ld      ZMem[sp],pc             ;
        ld      ZMem[sp],#0x10          ;
        ld      ZMem[sp],AddOpr         ;
        ld      ZMem[sp],[hl]           ;
        ld      ZMem[sp],[ix]           ;
        ld      ZMem[sp],[iy]           ;
        ld      ZMem[sp],ZMem[sp]       ;

        ;***********************************************************
        ;ld 8bit
        ld      a,a                     ; 40
        ld      a,b                     ; 41
        ld      a,l                     ; 42
        ld      a,h                     ; 43
        ld      a,br                    ; CE C0
        ld      a,sc                    ; CE C1
        ld      a,#0x10                 ; B0 10
        ld      a,[br:ll]               ; 44 ??
        ld      a,AddOpr                ; CE D0 ?? ??
        ld      a,[hl]                  ; 45
        ld      a,[ix]                  ; 46
        ld      a,[iy]                  ; 47
        ld      a,ZMem[ix]              ; CE 40 ??
        ld      a,ZMem[iy]              ; CE 41 ??
        ld      a,[ix+l]                ; CE 42
        ld      a,[iy+l]                ; CE 43
        ld      a,nb                    ; CE C8
        ld      a,ep                    ; CE C9
        ld      a,xp                    ; CE CA
        ld      a,yp                    ; CE CB

        ld      b,a                     ; 48
        ld      b,b                     ; 49
        ld      b,l                     ; 4A
        ld      b,h                     ; 4B
        ld      b,#0x10                 ; B1 10
        ld      b,[br:ll]               ; 4C ??
        ld      b,AddOpr                ; CE D1 ?? ??
        ld      b,[hl]                  ; 4D
        ld      b,[ix]                  ; 4E
        ld      b,[iy]                  ; 4F
        ld      b,ZMem[ix]              ; CE 48 ??
        ld      b,ZMem[iy]              ; CE 49 ??
        ld      b,[ix+l]                ; CE 4A
        ld      b,[iy+l]                ; CE 4B

        ld      l,a                     ; 50
        ld      l,b                     ; 51
        ld      l,l                     ; 52
        ld      l,h                     ; 53
        ld      l,#0x10                 ; B2 10
        ld      l,[br:ll]               ; 54 ??
        ld      l,AddOpr                ; CE D2 ?? ??
        ld      l,[hl]                  ; 55
        ld      l,[ix]                  ; 56
        ld      l,[iy]                  ; 57
        ld      l,ZMem[ix]              ; CE 50 ??
        ld      l,ZMem[iy]              ; CE 51 ??
        ld      l,[ix+l]                ; CE 52
        ld      l,[iy+l]                ; CE 53

        ld      h,a                     ; 58
        ld      h,b                     ; 59
        ld      h,l                     ; 5A
        ld      h,h                     ; 5B
        ld      h,#0x10                 ; B3 10
        ld      h,[br:ll]               ; 5C ??
        ld      h,AddOpr                ; CE D3 ?? ??
        ld      h,[hl]                  ; 5D
        ld      h,[ix]                  ; 5E
        ld      h,[iy]                  ; 5F
        ld      h,ZMem[ix]              ; CE 58 ??
        ld      h,ZMem[iy]              ; CE 59 ??
        ld      h,[ix+l]                ; CE 5A
        ld      h,[iy+l]                ; CE 5B

        ld      br,a                    ; CE C2
        ld      br,#0x10                ; B4 10
        ld      sc,a                    ; CE C3
        ld      sc,#0x10                ; 9F 10

        ld      [br:ll],a               ; 78 ??
        ld      [br:ll],b               ; 79 ??
        ld      [br:ll],l               ; 7A ??
        ld      [br:ll],h               ; 7B ??
        ld      [br:ll],#0x10           ; 7D 10
        ld      [br:ll],[hl]            ; 7D ??
        ld      [br:ll],[ix]            ; 7E ??
        ld      [br:ll],[iy]            ; 7F ??

        ld      AddOpr,a                ; CE D4 ?? ??
        ld      AddOpr,b                ; CE D5 ?? ??
        ld      AddOpr,l                ; CE D6 ?? ??
        ld      AddOpr,h                ; CE D7 ?? ??

        ld      [hl],a                  ; 68
        ld      [hl],b                  ; 69
        ld      [hl],l                  ; 6A
        ld      [hl],h                  ; 6B
        ld      [hl],#0x10              ; B5 10
        ld      [hl],[br:ll]            ; 6C ??
        ld      [hl],[hl]               ; 6D
        ld      [hl],[ix]               ; 6E
        ld      [hl],[iy]               ; 6F
        ld      [hl],ZMem[ix]           ; CE 60 ??
        ld      [hl],ZMem[iy]           ; CE 61 ??
        ld      [hl],[ix+l]             ; CE 62
        ld      [hl],[iy+l]             ; CE 63

        ld      [ix],a                  ; 60
        ld      [ix],b                  ; 61
        ld      [ix],l                  ; 62
        ld      [ix],h                  ; 63
        ld      [ix],#0x10              ; B6 10
        ld      [ix],[br:ll]            ; 64 ??
        ld      [ix],[hl]               ; 65
        ld      [ix],[ix]               ; 66
        ld      [ix],[iy]               ; 67
        ld      [ix],ZMem[ix]           ; CE 68 ??
        ld      [ix],ZMem[iy]           ; CE 69 ??
        ld      [ix],[ix+l]             ; CE 6A
        ld      [ix],[iy+l]             ; CE 6B

        ld      [iy],a                  ; 70
        ld      [iy],b                  ; 71
        ld      [iy],l                  ; 72
        ld      [iy],h                  ; 73
        ld      [iy],#0x10              ; B7 10
        ld      [iy],[br:ll]            ; 74 ??
        ld      [iy],[hl]               ; 75
        ld      [iy],[ix]               ; 76
        ld      [iy],[iy]               ; 77
        ld      [iy],ZMem[ix]           ; CE 78 ??
        ld      [iy],ZMem[iy]           ; CE 79 ??
        ld      [iy],[ix+l]             ; CE 7A
        ld      [iy],[iy+l]             ; CE 7B

        ld      ZMem[ix],a              ; CE 44 ??
        ld      ZMem[ix],b              ; CE 4C ??
        ld      ZMem[ix],l              ; CE 54 ??
        ld      ZMem[ix],h              ; CE 5C ??

        ld      ZMem[iy],a              ; CE 45 ??
        ld      ZMem[iy],b              ; CE 4D ??
        ld      ZMem[iy],l              ; CE 55 ??
        ld      ZMem[iy],h              ; CE 5D ??

        ld      [ix+l],a                ; CE 46
        ld      [ix+l],b                ; CE 4E
        ld      [ix+l],l                ; CE 56
        ld      [ix+l],h                ; CE 5E

        ld      [iy+l],a                ; CE 47
        ld      [iy+l],b                ; CE 4F
        ld      [iy+l],l                ; CE 57
        ld      [iy+l],h                ; CE 5F

        ld      nb,a                    ; CE CC
        ld      nb,#0x10                ; CE C4 10
        ld      ep,a                    ; CE CD
        ld      ep,#0x10                ; CE C5 10
        ld      xp,a                    ; CE CE
        ld      xp,#0x10                ; CE C6 10
        ld      yp,a                    ; CE CF
        ld      yp,#0x10                ; CE C7 10
        ;***********************************************************
        ;ex
        ex      a,b                     ; CC
        ex      a,[hl]                  ; CD
        swap    a                       ; F6
        swap    [hl]                    ; F7
        ex      ba,hl                   ; C8
        ex      ba,ix                   ; C9
        ex      ba,iy                   ; CA
        ex      ba,sp                   ; CB
        ;***********************************************************
        ;bit
        bit     a,b                     ; 94
        bit     a,#0x10                 ; 96 10
        bit     b,#0x10                 ; 97 10
        bit     [br:ll],#0x10           ; DC ?? ??
        bit     [hl],#0x10              ; 95 10
        ;***********************************************************
        ;add
AddOpr: .blkw   1
        add     a,a                     ; 00
        add     a,b                     ; 01
        add     a,#0x10                 ; 02 10
        add     a,[br:ll]               ; 04 ??
        add     a,AddOpr                ; 05 ?? ??
        add     a,[hl]                  ; 03
        add     a,[ix]                  ; 06
        add     a,[iy]                  ; 07
        add     a,ZMem[ix]              ; CE 00 ??
        add     a,ZMem[iy]              ; CE 01 ??
        add     a,[ix+l]                ; CE 02
        add     a,[iy+l]                ; CE 03

        add     [hl],a                  ; CE 04
        add     [hl],#0x10              ; CE 05 10
        add     [hl],[ix]               ; CE 06
        add     [hl],[iy]               ; CE 07

        add     ba,ba                   ; CF 00
        add     ba,hl                   ; CF 01
        add     ba,ix                   ; CF 02
        add     ba,iy                   ; CF 03
        add     ba,#0x10                ; C0 10 00

        add     hl,ba                   ; CF 20
        add     hl,hl                   ; CF 21
        add     hl,ix                   ; CF 22
        add     hl,iy                   ; CF 23
        add     hl,#0x10                ; C1 10 00

        add     ix,ba                   ; CF 40
        add     ix,hl                   ; CF 41
        add     ix,#0x10                ; C2 10 00

        add     iy,ba                   ; CF 42
        add     iy,hl                   ; CF 43
        add     iy,#0x10                ; C3 10 00

        add     sp,ba                   ; CF 44
        add     sp,hl                   ; CF 45
        add     sp,#0x10                ; CF 68 10 00
        ;***********************************************************
        ;adc
        adc     a,a                     ; 08
        adc     a,b                     ; 09
        adc     a,#0x10                 ; 0A ??
        adc     a,[br:ll]               ; 0C ??
        adc     a,AddOpr                ; 0D ?? ??
        adc     a,[hl]                  ; 0B
        adc     a,[ix]                  ; 0E
        adc     a,[iy]                  ; 0F
        adc     a,ZMem[ix]              ; CE 08 ??
        adc     a,ZMem[iy]              ; CE 09 ??
        adc     a,[ix+l]                ; CE 0A
        adc     a,[iy+l]                ; CE 0B

        adc     [hl],a                  ; CE 0C
        adc     [hl],#0x10              ; CE 0D ??
        adc     [hl],[ix]               ; CE 0E
        adc     [hl],[iy]               ; CE 0F

        adc     ba,ba                   ; CF 04
        adc     ba,hl                   ; CF 05
        adc     ba,ix                   ; CF 06
        adc     ba,iy                   ; CF 07
        adc     ba,#0x10                ; CF 60 ?? ??

        adc     hl,ba                   ; CF 24
        adc     hl,hl                   ; CF 25
        adc     hl,ix                   ; CF 26
        adc     hl,iy                   ; CF 27
        adc     hl,#0x10                ; CF 61 ?? ??
        ;***********************************************************
        ;sub
        sub     a,a                     ; 10
        sub     a,b                     ; 11
        sub     a,#0x10                 ; 12 ??
        sub     a,[br:ll]               ; 14 ??
        sub     a,AddOpr                ; 15 ?? ??
        sub     a,[hl]                  ; 13
        sub     a,[ix]                  ; 16
        sub     a,[iy]                  ; 17
        sub     a,ZMem[ix]              ; CE 10 ??
        sub     a,ZMem[iy]              ; CE 11 ??
        sub     a,[ix+l]                ; CE 12
        sub     a,[iy+l]                ; CE 13

        sub     [hl],a                  ; CE 14
        sub     [hl],#0x10              ; CE 15 ??
        sub     [hl],[ix]               ; CE 16
        sub     [hl],[iy]               ; CE 17

        sub     ba,ba                   ; CF 08
        sub     ba,hl                   ; CF 09
        sub     ba,ix                   ; CF 0A
        sub     ba,iy                   ; CF 0B
        sub     ba,#0x10                ; D0 ?? ??

        sub     hl,ba                   ; CF 28
        sub     hl,hl                   ; CF 29
        sub     hl,ix                   ; CF 2A
        sub     hl,iy                   ; CF 2B
        sub     hl,#0x10                ; D1 ?? ??

        sub     ix,ba                   ; CF 48
        sub     ix,hl                   ; CF 49
        sub     ix,#0x10                ; D2 ?? ??

        sub     iy,ba                   ; CF 4A
        sub     iy,hl                   ; CF 4B
        sub     iy,#0x10                ; D3 ?? ??

        sub     sp,ba                   ; CF 4C
        sub     sp,hl                   ; CF 4D
        sub     sp,#0x10                ; CF 6A ?? ??
        ;***********************************************************
        ;sbc
        sbc     a,a                     ; 18
        sbc     a,b                     ; 19
        sbc     a,#0x10                 ; 1A ??
        sbc     a,[br:ll]               ; 1C ??
        sbc     a,AddOpr                ; 1D ?? ??
        sbc     a,[hl]                  ; 1B
        sbc     a,[ix]                  ; 1E
        sbc     a,[iy]                  ; 1F
        sbc     a,ZMem[ix]              ; CE 18 ??
        sbc     a,ZMem[iy]              ; CE 19 ??
        sbc     a,[ix+l]                ; CE 1A
        sbc     a,[iy+l]                ; CE 1B

        sbc     [hl],a                  ; CE 1C
        sbc     [hl],#0x10              ; CE 1D ??
        sbc     [hl],[ix]               ; CE 1E
        sbc     [hl],[iy]               ; CE 1F

        sbc     ba,ba                   ; CF 0C
        sbc     ba,hl                   ; CF 0D
        sbc     ba,ix                   ; CF 0E
        sbc     ba,iy                   ; CF 0F
        sbc     ba,#0x10                ; CF 62 ?? ??
        sbc     hl,ba                   ; CF 2C
        sbc     hl,hl                   ; CF 2D
        sbc     hl,ix                   ; CF 2E
        sbc     hl,iy                   ; CF 2F
        sbc     hl,#0x10                ; CF 63 ?? ??
        ;***********************************************************
        ;and
        and     a,a                     ; 20
        and     a,b                     ; 21
        and     a,#0x10                 ; 22 10
        and     a,[br:ll]               ; 24 ??
        and     a,AddOpr                ; 25 ?? ??
        and     a,[hl]                  ; 23
        and     a,[ix]                  ; 26
        and     a,[iy]                  ; 27
        and     a,ZMem[ix]              ; CE 20 ??
        and     a,ZMem[iy]              ; CE 21 ??
        and     a,[ix+l]                ; CE 22
        and     a,[iy+l]                ; CE 23

        and     [hl],a                  ; CE 24
        and     [hl],#0x10              ; CE 25 10
        and     [hl],[ix]               ; CE 26
        and     [hl],[iy]               ; CE 27
        and     b,#0x10                 ; CE B0 10
        and     l,#0x10                 ; CE B1 10
        and     h,#0x10                 ; CE B2 10
        and     sc,#0x10                ; 9C 10
        and     [br:ll],#0x10           ; D8 ?? 10
        ;***********************************************************
        ;or
        or      a,a                     ; 28
        or      a,b                     ; 29
        or      a,#0x10                 ; 2A 10
        or      a,[br:ll]               ; 2C ??
        or      a,AddOpr                ; 2D ?? ??
        or      a,[hl]                  ; 2B
        or      a,[ix]                  ; 2E
        or      a,[iy]                  ; 2F
        or      a,ZMem[ix]              ; CE 28 ??
        or      a,ZMem[iy]              ; CE 29 ??
        or      a,[ix+l]                ; CE 2A
        or      a,[iy+l]                ; CE 2B

        or      [hl],a                  ; CE 2C
        or      [hl],#0x10              ; CE 2D 10
        or      [hl],[ix]               ; CE 2E
        or      [hl],[iy]               ; CE 2F
        or      b,#0x10                 ; CE B4 10
        or      l,#0x10                 ; CE B5 10
        or      h,#0x10                 ; CE B6 10
        or      sc,#0x10                ; 9D 10
        or      [br:ll],#0x10           ; D9 ?? 10
        ;***********************************************************
        ;cp
        cp      a,a                     ; 30
        cp      a,b                     ; 31
        cp      a,#0x10                 ; 32 10
        cp      a,[br:ll]               ; 34 ??
        cp      a,AddOpr                ; 35 ?? ??
        cp      a,[hl]                  ; 33
        cp      a,[ix]                  ; 36
        cp      a,[iy]                  ; 37
        cp      a,ZMem[ix]              ; CE 30 ??
        cp      a,ZMem[iy]              ; CE 31 ??
        cp      a,[ix+l]                ; CE 32
        cp      a,[iy+l]                ; CE 33

        cp      [hl],a                  ; CE 34
        cp      [hl],#0x10              ; CE 35 10
        cp      [hl],[ix]               ; CE 36
        cp      [hl],[iy]               ; CE 37
        cp      b,#0x10                 ; CE BC 10
        cp      l,#0x10                 ; CE BD 10
        cp      h,#0x10                 ; CE BE 10
        cp      sc,#0x10                ; CE BF ??
        cp      [br:ll],#0x10           ; DB ?? 10

        cp      ba,ba                   ; CF 18
        cp      ba,hl                   ; CF 19
        cp      ba,ix                   ; CF 1A
        cp      ba,iy                   ; CF 1B
        cp      ba,#0x10                ; D4 10 mm
        cp      hl,ba                   ; CF 38
        cp      hl,hl                   ; CF 39
        cp      hl,ix                   ; CF 3A
        cp      hl,iy                   ; CF 3B
        cp      hl,#0x10                ; D5 10 mm
        cp      ix,ba
        cp      ix,hl
        cp      ix,#0x10                ; D6 10 mm
        cp      iy,ba
        cp      iy,hl
        cp      iy,#0x10                ; D7 10 mm
        cp      sp,ba                   ; CF 5C
        cp      sp,hl                   ; CF 5D
        cp      sp,#0x10                ; CF 6C 10 mm
        ;***********************************************************
        ;xor
        xor     a,a                     ; 38
        xor     a,b                     ; 39
        xor     a,#0x10                 ; 3A 10
        xor     a,[br:ll]               ; 3C ??
        xor     a,AddOpr                ; 3D ?? ??
        xor     a,[hl]                  ; 3B
        xor     a,[ix]                  ; 3E
        xor     a,[iy]                  ; 3F
        xor     a,ZMem[ix]              ; CE 38 ??
        xor     a,ZMem[iy]              ; CE 39 ??
        xor     a,[ix+l]                ; CE 3A
        xor     a,[iy+l]                ; CE 3B

        xor     [hl],a                  ; CE 3C
        xor     [hl],#0x10              ; CE 3D 10
        xor     [hl],[ix]               ; CE 3E
        xor     [hl],[iy]               ; CE 3F
        xor     b,#0x10                 ; CE B8 10
        xor     l,#0x10                 ; CE B9 10
        xor     h,#0x10                 ; CE BA 10
        xor     sc,#0x10                ; 9E 10
        xor     [br:ll],#0x10           ; DA ?? 10
        ;***********************************************************
        ;complement operand
        cpl     a                       ; CE A0
        cpl     b                       ; CE A1
        cpl     [br:ll]                 ; CE A2,??
        cpl     [hl]                    ; CE A3
        ;***********************************************************
        ;negative operand
        neg     a                       ; CE A4
        neg     b                       ; CE A5
        neg     [br:ll]                 ; CE A6,??
        neg     [hl]                    ; CE A7
        ;***********************************************************
        ;increment operand
        inc     a                       ; 80
        inc     b                       ; 81
        inc     l                       ; 82
        inc     h                       ; 83
        inc     br                      ; 84
        inc     [br:ll]                 ; 85 ??
        inc     [hl]                    ; 86
        inc     ba                      ; 90
        inc     hl                      ; 91
        inc     ix                      ; 92
        inc     iy                      ; 93
        inc     sp                      ; 87
        ;***********************************************************
        ;decrement operand
        dec     a                       ; 88
        dec     b                       ; 89
        dec     l                       ; 8A
        dec     h                       ; 8B
        dec     br                      ; 8C
        dec     [br:ll]                 ; 8D ??
        dec     [hl]                    ; 8E
        dec     ba                      ; 98
        dec     hl                      ; 99
        dec     ix                      ; 9A
        dec     iy                      ; 9B
        dec     sp                      ; 8F
        ;***********************************************************
        ;other arithmetic operations
        mlt                             ; CE D8
        div                             ; CE D9
        pack                            ; DE
        upck                            ; DF
        sep                             ; CE A8
        ;***********************************************************
        ;rotate right through carry
        rl      a                       ; CE 90
        rl      b                       ; CE 91
        rl      [br:ll]                 ; CE 92 ??
        rl      [hl]                    ; CE 93
        ;***********************************************************
        ;rotate operand left circular
        rlc     a                       ; CE 94
        rlc     b                       ; CE 95
        rlc     [br:ll]                 ; CE 96 ??
        rlc     [hl]                    ; CE 97
        ;***********************************************************
        ;rotate right through carry
        rr      a                       ; CE 98
        rr      b                       ; CE 99
        rr      [br:ll]                 ; CE 9A ??
        rr      [hl]                    ; CE 9B
        ;***********************************************************
        ;rotate operand right circular
        rrc     a                       ; CE 9C
        rrc     b                       ; CE 9D
        rrc     [br:ll]                 ; CE 9E ??
        rrc     [hl]                    ; CE 9F
        ;***********************************************************
        ;shift operand left arithmetic
        sla     a                       ; CE 80
        sla     b                       ; CE 81
        sla     [br:ll]                 ; CE 82 ??
        sla     [hl]                    ; CE 83
        ;***********************************************************
        ;shift operand left logical
        sll     a                       ; CE 84
        sll     b                       ; CE 85
        sll     [br:ll]                 ; CE 86 ??
        sll     [hl]                    ; CE 87
        ;***********************************************************
        ;shift operand right arithmetic
        sra     a                       ; CE 88
        sra     b                       ; CE 89
        sra     [br:ll]                 ; CE 8A ??
        sra     [hl]                    ; CE 8B
        ;***********************************************************
        ;shift operand right logical
        srl     a                       ; CE 8C
        srl     b                       ; CE 8D
        srl     [br:ll]                 ; CE 8E ??
        srl     [hl]                    ; CE 8F
        ;***********************************************************
        ;load destination with top of stack
        pop     a                       ; CF B4
        pop     b                       ; CF B5
        pop     l                       ; CF B6
        pop     h                       ; CF B7
        pop     br                      ; AC
        pop     sc                      ; AF
        pop     ba                      ; A8
        pop     hl                      ; A9
        pop     ix                      ; AA
        pop     iy                      ; AB
        pop     ep                      ; AD
        pop     ip                      ; AE
        pop     all                     ; CF BC
        pop     ale                     ; CF BD
        ;***********************************************************
        ;put source on stack
        push    a                       ; CF B0
        push    b                       ; CF B1
        push    l                       ; CF B2
        push    h                       ; CF B3
        push    br                      ; A4
        push    sc                      ; A7
        push    ba                      ; A0
        push    hl                      ; A1
        push    ix                      ; A2
        push    iy                      ; A3
        push    ep                      ; A5
        push    ip                      ; A6
        push    all                     ; CF B8
        push    ale                     ; CF B9
        ;***********************************************************
        ;unconditional jump relative to HL
        jp      hl                      ; F4
        jp      ZMem                    ; FD ??
        ;***********************************************************
        ;unconditional jump relative to PC+e
        jrs     djr0+0xF                ; F1 10
        ;***********************************************************
        ;jump relative to PC+e if condition is true
djr0:   djr     NZ,jrs01+0xF            ; F5 10
jrs01:  jrs     C,jrs02+0xF             ; E4 10
jrs02:  jrs     NC,jrs03+0xF            ; E5 10
jrs03:  jrs     Z,jrs04+0xF             ; E6 10
jrs04:  jrs     NZ,jrs05+0xF            ; E7 10
jrs05:  jrs     LT,jrs06+0xF            ; CE E0 10
jrs06:  jrs     LE,jrs07+0xF            ; CE E1 10
jrs07:  jrs     GT,jrs08+0xF            ; CE E2 10
jrs08:  jrs     GE,jrs09+0xF            ; CE E3 10
jrs09:  jrs     V,jrs10+0xF             ; CE E4 10
jrs10:  jrs     NV,jrs11+0xF            ; CE E5 10
jrs11:  jrs     P,jrs12+0xF             ; CE E6 10
jrs12:  jrs     M,jrs13+0xF             ; CE E7 10
jrs13:  jrs     F0,jrs14+0xF            ; CE E8 10
jrs14:  jrs     F1,jrs15+0xF            ; CE E9 10
jrs15:  jrs     F2,jrs16+0xF            ; CE EA 10
jrs16:  jrs     F3,jrs17+0xF            ; CE EB 10
jrs17:  jrs     NF0,jrs18+0xF           ; CE EC 10
jrs18:  jrs     NF1,jrs19+0xF           ; CE ED 10
jrs19:  jrs     NF2,jrs20+0xF           ; CE EE 10
jrs20:  jrs     NF3,jrs21+0xF           ; CE EF 10
jrs21:
        ;***********************************************************
        ;unconditional jump relative to PC+e
        jrl     jrl01+0xF               ; F3 10 00
        ;***********************************************************
        ;jump relative to PC+e if condition is true
jrl01:  jrl     C,jrl02+0xF             ; EC 10 00
jrl02:  jrl     NC,jrl03+0xF            ; ED 10 00
jrl03:  jrl     Z,jrl04+0xF             ; EE 10 00
jrl04:  jrl     NZ,jrl05+0xF            ; EF 10 00
jrl05:
        ;***********************************************************
        ;unconditional call short relative to PC+e
        cars    cars01+0xF              ; F0 10
        ;***********************************************************
        ;call short relative to PC+e if condition is true
cars01: cars    C,cars02+0xF            ; E0 10
cars02: cars    LT,cars03+0xF           ; CE F0 10
cars03: cars    LE,cars04+0xF           ; CE F1 10
cars04: cars    GT,cars05+0xF           ; CE F2 10
cars05: cars    GE,cars06+0xF           ; CE F3 10
cars06: cars    V,cars07+0xF            ; CE F4 10
cars07: cars    NV,cars08+0xF           ; CE F5 10
cars08: cars    P,cars09+0xF            ; CE F6 10
cars09: cars    M,cars10+0xF            ; CE F7 10
cars10: cars    F0,cars11+0xF           ; CE F8 10
cars11: cars    F1,cars12+0xF           ; CE F9 10
cars12: cars    F2,cars13+0xF           ; CE FA 10
cars13: cars    F3,cars14+0xF           ; CE FB 10
cars14: cars    NF0,cars15+0xF          ; CE FC 10
cars15: cars    NF1,cars16+0xF          ; CE FD 10
cars16: cars    NF2,cars17+0xF          ; CE FE 10
cars17: cars    NF3,cars18+0xF          ; CE FF 10
cars18:
        ;***********************************************************
        ;unconditional call long relative to PC+e
        carl    carl01+0xF              ; F2 10 00
        ;***********************************************************
        ;call long relative to PC+e if condition is true
carl01: carl    C,carl02+0xF            ; E8 10 00
carl02: carl    NC,carl03+0xF           ; E9 10 00
carl03: carl    Z,carl04+0xF            ; EA 10 00
carl04: carl    NZ,carl05+0xF           ; EB 10 00
carl05:
        ;***********************************************************
        ;unconditional indirect call
IndCall:.blkw   1
        call    IndCall                 ; FB ?? ??
        int     ZMem                    ; FC ??
        ;***********************************************************
        ;return from subroutine
        ret                             ; F8
        rete                            ; F9
        rets                            ; FA
        ;***********************************************************
        ;no operation
        nop                             ; FF
        ;***********************************************************
        ;halt
        halt                            ; CE AE
        slp                             ; CE AF
