	include	pccard.mac
	include	api.inc
	include	userprog.inc

	data

Score:	db	[2]
Count:	db	[1]
L1:	db	[25]
L2:	db	[25]
L3:	db	[25]
L4:	db	[25]
L5:	db	[25]

	code

SampleProg:
	dw	loc FontDisp
	dw	loc GraphTest
	dw	loc KeySample
	dw	loc Mimizu
	dw	loc Nomi

SampleMenu1:
	db	0BBh,0DDh,0CCh,0DFh,0D9h,0D2h,0C6h,0ADh,0B0h,' ',' ',' '	; "ƭ   "
	db	' ',0B7h,0ACh,0D7h,0B8h,0C0h,0B2h,0C1h,0D7h,0DDh,' ',' '	; " ׸  "
	db	' ',0B8h,0DEh,0D7h,0CCh,0A8h,0AFh,0B8h,0C3h,0BDh,0C4h,' '	; " ̨ý "
	db	0

SampleMenu2:
	db	' ',0C0h,0AFh,0C1h,0B7h,0B0h,0C3h,0BDh,0C4h,' ',' ',' '		; " ý   "
	db	' ',0B9h,0DEh,0B0h,0D1h,'1',' ',' ',' ',' ',' ',' '		; " ް1      "
	db	' ',0B9h,0DEh,0B0h,0D1h,'2',' ',' ',' ',' ',' ',' '		; " ް2      "
	db	0

WorkAdd:
	dw	L1,L2,L3,L4,L5


; Sample
;	TvvO`[
;	eTvvO[C/CE]ŏI܂
;
;	IN:	
;
;	OUT:	(߂܂)
;
;	Reg.	
;
Sample:
	push	ale

	ld	b,#0			; B<- Menu No.

SampleLoop:
1$:	ld	ep,#pod SampleProg
	ld	xp,#pod SampleMenu1

	API	CursorOff
	xor	a,a
	API	SetTextSize
	API	ClearScreen

10$:	ld	a,b
	cp	b,#2
	jr	nc,11$

	ld	ix,#lod SampleMenu1
	inc	a
	jr	12$

11$:	ld	ix,#lod SampleMenu2
	sub	a,#2
12$:	sub	hl,hl	;ld	hl,#0000h
	API	PutStr

	ld	h,a
	ld	l,#0
	ld	a,#10h
	API	PutChar

2$:	halt
	API	InKey
	or	a,a
	jr	z,2$

	cp	a,#KCD_UP
	jr	nz,21$

	cp	b,#0
	jr	z,2$

	dec	b
	jr	10$

21$:	cp	a,#KCD_DOWN
	jr	nz,22$

	cp	b,#4
	jr	z,2$

	inc	b
	jr	10$

22$:	cp	a,#KCD_CCE
	jr	nz,23$

	pop	ale
	jp	[0feh]

23$:	cp	a,#KCD_OK
	jr	nz,2$

	ld	l,b
	ld	h,#0
	add	hl,hl
	add	hl,#lod SampleProg
	ld	hl,[hl]
	push	b
	jp	hl

SampleExit:
	pop	b
	jr	SampleLoop


; KeySample
;	L[́EҏW^gʃeXg
;
;	IN:	
;
;	OUT:	
;
;	Reg.	Sj
;
;===========================================================================
;gp@
;
;	L[ƁAݒ肳ĂJISCIIR[hɑΉ镶ʂɕ\
;	܂B
;	ʂ24x5̊g[hœ삵APsڂ10,12,14,16,18̕ҏW
;	\łB
;===========================================================================
KeySample:
	ld	hl,#L1
	ld	b,#125
	sub	a,a
111$:	ld	[hl],a
	inc	hl
	djr	nz,111$

	ld	a,#KBD_KANA
	API	KeyMode

	ld	a,#0ffh			; 24x5 extend-screen
	API	SetTextSize		;

	API	ClearScreen

	API	CursorOn
	ld	hl,#0
	API	Locate

1$:	API	GetPos
	ld	a,h
	sll	a
	ld	l,a
	ld	h,#0
	add	hl,#WorkAdd
	ld	ix,[hl]
	ld	xp,#pod L1

	add	a,#10
	API	GetPos
	API	Input
	API	Locate

	cp	a,#KCD_UP
	jr	nz,11$

	cp	h,#0
	jr	z,1$

	dec	h
	jr	2$
	API	Locate
	jr	9$

11$:	cp	a,#KCD_DOWN
	jr	nz,12$

	cp	h,#4
	jr	z,1$

	inc	h
2$:	API	Locate
	jr	9$

12$:	cp	a,#KCD_CCE
	jr	z,SampleExit

9$:	jr	1$

; GraphTest
;	OtBbN\eXg
;
;	IN:	
;
;	OUT:	(߂܂)
;
;	Reg.	
;
;===========================================================================
;gp@
;
;	NƓɉʏ̃_ȈʒuɃhbgł肵
;	Biꂾłj
;===========================================================================
GraphTest:
	API	PowerSaveLock
	API	ClearScreen
1$:	API	InKey
	cp	a,#KCD_CCE
	jr	z,SampleExit

	API	Random
	ld	l,a
	ld	h,#0
	ld	a,#6
	div
	ld	b,h
	API	Random
	ld	l,a
	ld	h,#0
	ld	a,#24
	div
	ld	a,h
	ld	hl,ba
	API	Point
	or	a,a
	jr	z,11$

	xor	a,a
	jr	12$

11$:	ld	a,#0ffh
12$:	API	Pset
	jr	1$


; FontDisp
;	tHgꗗ\
;
;	IN:	
;
;	OUT:	(߂܂)
;
;	Reg.	
;
;===========================================================================
;gp@
;
;	StHg\܂B
;	Py[WƂɒ~܂B
;	ĊJ͓KȃL[ĂB
;===========================================================================
FontDisp:
	API	ClearScreen
	ld	a,#0
	ld	hl,#0

1$:	API	PutChar
	inc	a
	inc	l
	cp	l,#XSize
	jr	nz,1$

	ld	l,#0
	inc	h
	cp	h,#YSize
	jr	nz,1$

	ld	h,#0

	ex	a,b
2$:	halt
	API	InKey
	or	a,a
	jr	z,2$

	cp	a,#KCD_CCE
	jr	z,SampleExit

	ex	a,b
	jr	1$


; Mimizu
;	TvQ[	u~~Ỷv
;
;	IN:	
;
;	OUT:	(߂܂)
;
;	Reg.	
;
;===========================================================================
;Vѕ
;
;	Ḿu~~YNv𑀂āA΂ɂԂȂ悤ɂĂ܂B
;
;	u~~YNv [] ŏցA[] ŉֈړ܂B
;
;	Q[X^[g [OK] łB
;
;	ʂقڒ o.... M̑u~~YNvłB
;	ʍ猻 # ͐΂łB
;	X $ ܂Áu~~YNv̉aŁA܂Hׂ10_
;	B
;	Pړ1_ZłB
;
;	āAM͉_܂ł܂H
;===========================================================================
Mimizu:
	ld	ep,#pod Score
	ld	a,#KBD_NUMLOCK|KBD_SFTNUM
	API	KeyMode
	API	PowerSaveLock
	API	ClearScreen

	jr	100$

1$:	ld	a,#20
	API	WaitTimerReset

	ld	hl,ix
	ld	a,#'.'
	API	PutChar

	API	InKey
	cp	a,#KCD_UP		; UP Key
	jr	nz,11$

	cp	h,#0
	jr	z,3$

	dec	h
	ld	ix,hl
	jr	3$

11$:	cp	a,#KCD_RIGHT		; DOWN Key
	jr	nz,12$

	cp	h,#2
	jr	z,3$

	inc	h
	ld	ix,hl
	jr	3$

12$:	cp	a,#KCD_CCE
	jr	z,SampleExit

3$:	API	ScrollRight

	ld	hl,#XSize-4
	ld	a,[br:low Score+1]
	ld	b,#0
	API	PutNum2
	ld	a,[br:low Score]
	API	PutNum22

	ld	hl,ix
	API	GetChar
	cp	a,#'$'
	jr	nz,31$

	ld	ba,[Score]
	add	a,#10
	cp	a,#100
	jr	c,301$

	ld	l,a
	ld	h,#0
	ld	a,#100
	div
	ld	a,b
	ld	b,l
	add	a,b
	ld	b,a
	ld	a,h
	cp	b,#100
	jr	c,301$

	ld	b,#0
301$:	ld	[Score],ba
	jr	311$

31$:	cp	a,#' '
	jr	nz,5$

311$:	API	Random
	bit	a,#0c0h
	jr	z,4$

	cp	a,#0fah
	jr	c,32$

	ld	b,#'$'
	jr	33$

32$:	ld	b,#'#'
33$:	ld	l,a
	ld	h,#0
	ld	a,#3
	div
	ld	l,#0
	ld	a,b
	API	PutChar

4$:	ld	hl,ix
	ld	a,#'o'
	API	PutChar

	ld	ba,[Score]
	inc	a
	cp	a,#100
	jr	c,41$

	xor	a,a
	inc	b
	cp	b,#100
	jr	c,41$

	ld	b,#0
41$:	ld	[Score],ba

42$:	halt
	API	WaitTimer
	or	a,a
	jr	nz,42$

	jr	1$

5$:	car	BombBlink

100$:	ld	hl,#0100h
	ld	xp,#pod MimizuMsg
	ld	ix,#lod MimizuMsg
	API	PutStr

51$:	API	InKey
	or	a,a
	jr	nz,51$

52$:	halt
	API	InKey
	cp	a,#KCD_CCE
	jr	z,SampleExit

	cp	a,#KCD_OK
	jr	nz,52$

	ld	br,#high Score
	sub	ba,ba
	ld	[Score],ba

	API	ClearScreen
	ld	ix,#0100h+XSize-5
	jr	1$


; Nomi
;	TvQ[	um~̃nCWvv
;
;	IN:	
;
;	OUT:	(߂܂)
;
;	Reg.	
;
;===========================================================================
;Vѕ
;
;	Ḿum~v𑀂āA΂щzĂB
;
;	um~v [] ĂԃWvAΗĂ܂B
;	AR܂łWvĂ邱Ƃ͂ł܂B
;	ŏ_(ʏ㕔)łUȏړƎIɗĂ܂܂B
;
;	O[]AuԂɉĂB
;	(A^C~O͔ɃVrAł)
;
;	Q[X^[g [OK] łB
;
;	ʂقڒ m.... M̑um~vłB
;	ʍ猻 # ͐΂łB
;	X $ ܂Áum~v̉aŁA܂Hׂ10_
;	łB
;	Pړ1_ZłB
;
;	āAM͉_܂ł܂H
;===========================================================================
Nomi:
	ld	ep,#pod Score
	ld	a,#KBD_NUMLOCK|KBD_SFTNUM
	API	KeyMode
	API	PowerSaveLock
	API	ClearScreen

	jr	100$

1$:	ld	a,#20
	API	WaitTimerReset

	ld	hl,ix
	ld	a,#'.'
	API	PutChar

	API	ReadKey
	cp	a,#0ffh
	jr	nz,2$

	ld	[br:low Count],#6

11$:	cp	h,#2
	jr	z,3$

	inc	h
	ld	ix,hl
	jr	3$

2$:	cp	a,#23			; JUMP Key
	jr	nz,21$

	cp	[br:low Count],#0
	jr	z,11$

	dec	[br:low Count]

	cp	h,#0
	jr	z,3$

	dec	h
	ld	ix,hl
	jr	3$

21$:	cp	a,#6			; CCE key
	jr	z,SampleExit

3$:	API	ScrollRight

	ld	hl,#XSize-4
	ld	a,[br:low Score+1]
	ld	b,#0
	API	PutNum2
	ld	a,[br:low Score]
	API	PutNum22

	ld	hl,ix
	API	GetChar
	cp	a,#'$'
	jr	nz,31$

	ld	ba,[Score]
	add	a,#10
	cp	a,#100
	jr	c,301$

	ld	l,a
	ld	h,#0
	ld	a,#100
	div
	ld	a,b
	ld	b,l
	add	a,b
	ld	b,a
	ld	a,h
	cp	b,#100
	jr	c,301$

	ld	b,#0
301$:	ld	[Score],ba
	jr	311$

31$:	cp	a,#' '
	jr	nz,5$

311$:	API	Random
	bit	a,#0c0h
	jr	z,4$

	cp	a,#0fah
	jr	c,32$

	ld	b,#'$'
	jr	33$

32$:	ld	b,#'#'
33$:	ld	l,a
	ld	h,#0
	ld	a,#3
	div
	cp	h,#0
	jr	z,4$

	ld	a,b
	cp	h,#1
	jr	z,34$

	ld	hl,#0100h
	API	PutChar
34$:	ld	hl,#0200h
	API	PutChar

4$:	ld	hl,ix
	ld	a,#'m'
	API	PutChar

	ld	ba,[Score]
	inc	a
	cp	a,#100
	jr	c,41$

	xor	a,a
	inc	b
	cp	b,#100
	jr	c,41$

	ld	b,#0
41$:	ld	[Score],ba

42$:	halt
	API	WaitTimer
	or	a,a
	jr	nz,42$

	jr	1$

5$:	car	BombBlink

100$:	ld	hl,#0100h
	ld	xp,#pod NomiMsg
	ld	ix,#lod NomiMsg
	API	PutStr

51$:	API	InKey
	or	a,a
	jr	nz,51$

52$:	halt
	API	InKey
	cp	a,#KCD_CCE
	jr	z,SampleExit

	cp	a,#KCD_OK
	jr	nz,52$

	ld	br,#high Score
	sub	ba,ba
	ld	[Score],ba
	ld	[br:low Count],#6

	API	ClearScreen
	ld	ix,#0200h+XSize-5
	jr	1$


BombBlink:
	push	ba
	push	hl
	push	ix
	push	ip

	ld	a,#pod SubScreen
	ld	hl,#lod SubScreen
	API	SetTextBuffer

	ld	b,#9
	ld	hl,#0000h
	API	Locate
	ld	xp,#pod BombChar
	ld	ix,#lod BombChar

1$:	ld	a,[ix]
	push	b
	ld	b,#XSize*YSize
2$:	API	PutChar2
	djr	nz,2$
	pop	b

	ld	a,#10
	API	Wait

	inc	ix
	djr	nz,1$

	ld	a,#0ffh
	API	SetTextBuffer

	pop	ip
	pop	ix
	pop	hl
	pop	ba

	ret

BombChar:
	db	98h,99h,9ah,9bh,9ch,9bh,9ah,99h,98h

MimizuMsg:
	db	0D0h,0D0h,0BDh,0DEh,0C9h,0D6h,0BAh,0CAh,0DEh,0B2h,' ',' '
	db	0B9h,0DEh,0B0h,0D1h,20h,0BDh,0C0h,0B0h,0C4h,'=','O','K',0

NomiMsg:
	db	0C9h,0D0h,0C9h,0CAh,0B2h,0BCh,0DEh,0ACh,0DDh,0CCh,0DFh,' '
	db	0B9h,0DEh,0B0h,0D1h,20h,0BDh,0C0h,0B0h,0C4h,'=','O','K',0

SubScreen:
	db	[XSize*YSize]

	end
